import fullscreen.*; 
FullScreen fs;

import processing.video.*;
Capture video;

PVector[] matrix;
int stepWidth;
int countHorizontal;
int countVertical;
int countTotal;

int setSize = 30;
int setSpace = 15;
int setMargin = 20;

void setup(){
  
  frameRate(20);
  size(1680,1050);
  background(255);
  noStroke();
  smooth();
  
  //video = new Capture(this, width/30, height/30, 20);
  
  int iWidth = width - setMargin;
  int iHeight = height - setMargin;
  
  fs = new FullScreen(this); 
  fs.enter(); 
  
  stepWidth = setSize + setSpace;
  countHorizontal = iWidth / stepWidth ;
  countVertical = iHeight / stepWidth;
  countTotal = countHorizontal * countVertical;
    
  matrix = new PVector[countTotal];
  int i = 0;
  for(int y = stepWidth; y <= iHeight; y += stepWidth) {
    for(int x = stepWidth; x <= iWidth; x += stepWidth) {
      matrix[i] = new PVector(x, y, 0);
      i++;
    }
  }

}

void draw(){
    
  //background(255);
  fill(255, 200);
  rect(0,0,width,height);
  //image(video, 0, 0, width, height);
  
  PVector mouseVect = new PVector(mouseX, mouseY);
  //PVector mouseVect = getFocus();
  for(int i = 0; i < countTotal; i++) {
    float distValue = PVector.dist(mouseVect, matrix[i]);
    float angleMouse = atan2(mouseVect.y - matrix[i].y, mouseVect.x - matrix[i].x);
    float state = map(distValue, 0, width*1.41-70, 1, 7);
        
    pushMatrix();  
      translate(matrix[i].x, matrix[i].y);
        sign1(state, angleMouse);
    popMatrix();
    
  }

}

void sign1(float s, float a){

  pushMatrix();
  
    rotate(a);
    scale(map(s,1,7,1.3,0));

    fill(0);
    ellipse(0,0,setSize,setSize);
    
    fill(255);
    arc(0, 0, setSize+5, setSize+5, 0, map(a,1,7,PI/2,PI));
    
   popMatrix();
   
}
